function copytable(t)
    local new_table = {}
    for k, v in pairs(t) do
        new_table[k] = v
    end
    return new_table
end

local env = {
    assert = assert,
    error = error,
    ipairs = ipairs,
    next = next,
    pairs = pairs,
    print = print,
    tonumber = tonumber,
    tostring = tostring,
    select = select,
    type = type,
    unpack = unpack,
    _VERSION = _VERSION,
    bit = copytable(bit),
    io = { write = io.write },
    math = copytable(math),
    string = copytable(string),
    table = copytable(table),
    frob = frob,
    fry = fry,
}

unsafe_func, error_msg = loadstring(code)
if not unsafe_func then
    print(error_msg)
    return nil
end

setfenv(unsafe_func, env)

status, result = pcall(unsafe_func)
if not status then
    print(result)
    return nil
end

return result
